﻿Imports Microsoft.Win32

Public Class WindowImagem

    Private Sub btnCarregarImagem_Click(sender As Object, e As RoutedEventArgs)

        Dim dlg As New OpenFileDialog()
        dlg.InitialDirectory = "c:\dados"
        dlg.Filter = "Imagens (*.jpg)|*.jpg|Todos (*.*)|*.*"
        dlg.RestoreDirectory = True

        If dlg.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
        Else
            Dim arquivoSelecionado As String = dlg.FileName
            lblArquivo.Content = arquivoSelecionado
            Dim bitmap As New BitmapImage()
            bitmap.BeginInit()
            bitmap.UriSource = New Uri(arquivoSelecionado)
            bitmap.EndInit()
            imgArquivo.Source = bitmap
        End If

    End Sub

    Private Sub btnCopiar_Click(sender As Object, e As RoutedEventArgs)
        Try
            Dim width As Double = imgArquivo.ActualWidth
            Dim height As Double = imgArquivo.ActualHeight
            Dim bmpCopied As New RenderTargetBitmap(CInt(Math.Round(width)), CInt(Math.Round(height)), 96, 96, PixelFormats.[Default])
            Dim dv As New DrawingVisual()
            Using dc As DrawingContext = dv.RenderOpen()
                Dim vb As New VisualBrush(imgArquivo)
                dc.DrawRectangle(vb, Nothing, New Rect(New Point(), New Size(width, height)))
            End Using
            bmpCopied.Render(dv)
            Clipboard.SetImage(bmpCopied)
        Catch ex As Exception

        End Try
    End Sub
    Private Sub btnColar_Click(sender As Object, e As RoutedEventArgs)
        Try
            If Clipboard.ContainsImage() Then
                Dim clipboardData As System.Windows.Forms.IDataObject = System.Windows.Forms.Clipboard.GetDataObject()
                If clipboardData IsNot Nothing Then
                    If clipboardData.GetDataPresent(System.Windows.Forms.DataFormats.Bitmap) Then
                        Dim bitmap As System.Drawing.Bitmap = DirectCast(clipboardData.GetData(System.Windows.Forms.DataFormats.Bitmap), System.Drawing.Bitmap)
                        imgArquivo.Source = System.Windows.Interop.Imaging.CreateBitmapSourceFromHBitmap(bitmap.GetHbitmap(), IntPtr.Zero, Int32Rect.Empty, BitmapSizeOptions.FromEmptyOptions())
                    End If
                End If
            End If
        Catch ex As Exception

        End Try
    End Sub
End Class
